package com.jpsoft.picc.modules.business.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import com.jpsoft.picc.modules.common.constant.PolicyStatus;
import com.jpsoft.picc.modules.common.constant.StudentPolicyStatus;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:business_student_application的实体类
 */
@Data
@ApiModel(value = "business_student_application的实体类")
public class StudentApplication {
	@ApiModelProperty(value = "ID")
	private String id;
	@ApiModelProperty(value = "创建人")
	private String createBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;
	@ApiModelProperty(value = "更新人")
	private String updateBy;
	@DateTimeFormat(pattern="yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
	@ApiModelProperty(value = "更新时间")
	private Date updateTime;
	@ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	@ApiModelProperty(value = "保险种类")
	private String definitionId;
	@ApiModelProperty(value = "险种名称")
	private String definitionName;
	@ApiModelProperty(value = "投保单号")
	private String policyNo;
	@ApiModelProperty(value = "投保人ID")
	private String insuredId;
	@ApiModelProperty(value = "投保人姓名")
	private String insuredName;
	@ApiModelProperty(value = "投保人证件号码")
	private String insuredCard;
	@ApiModelProperty(value = "投保人联系电话")
	private String insuredTel;
	@ApiModelProperty(value = "性别")
	private String insuredSex;
	@ApiModelProperty(value = "是否有附加险")
	private Boolean haveAttach;
	@ApiModelProperty(value = "附加险投保人ID")
	private String attachId;
	@ApiModelProperty(value = "附加险投保人姓名")
	private String attachName;
	@ApiModelProperty(value = "附加险投保人证件号码")
	private String attachCard;
	@ApiModelProperty(value = "附加险投保人联系电话")
	private String attachTel;
	@ApiModelProperty(value = "亲属关系")
	private String attachRelationship;
	@ApiModelProperty(value = "有无医保")
	private Boolean haveMedicare;
	@DateTimeFormat(pattern="yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
	@ApiModelProperty(value = "保障开始时间")
	private Date startTime;
	@DateTimeFormat(pattern="yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
	@ApiModelProperty(value = "保障结束时间")
	private Date endTime;
	@ApiModelProperty(value = "保险费合计(总金额)")
	private BigDecimal insuranceFee;
	@ApiModelProperty(value = "状态:待缴费20/待审核30/待制单40/待签名50/已出单60/已过期100")
	private String status;
	@ApiModelProperty(value = "状态:待缴费20/待审核30/待制单40/待签名50/已出单60/已过期100(翻译)")
	private String statusN;
	@ApiModelProperty(value = "流程审核状态:正常/回退等")
	private String processStatus;
	@DateTimeFormat(pattern="yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "出单时间")
	private Date finishTime;
	@ApiModelProperty(value = "电子签名")
	private String signature;
	@ApiModelProperty(value = "电子签名2")
	private String signature2;
	@ApiModelProperty(value = "电子签名3")
	private String signature3;
	@ApiModelProperty(value = "支付订单号")
	private String paymentOrder;
	@ApiModelProperty(value = "学校ID")
	private String schoolId;
	@ApiModelProperty(value = "学校名称")
	private String schoolName;
	@ApiModelProperty(value = "班级ID")
	private String companyId;
	@ApiModelProperty(value = "班级名称")
	private String companyName;
	@ApiModelProperty(value = "入账银行")
	private String accountBank;
	@ApiModelProperty(value = "出账银行")
	private String issuingBank;
	@ApiModelProperty(value = "单号")
	private String singlNumber;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone ="GMT+8")
	@ApiModelProperty(value = "转账时间")
	private Date transferTime;


	/**
	 * 状态翻译
	 * @return
	 */
	public String getStatusN() {
		String statusN = "";
		if(status.equals("10")){
			statusN = StudentPolicyStatus.Draft.getText();
		}
		else if(status.equals("15")){
			statusN = StudentPolicyStatus.Back.getText();
		}
		else if(status.equals("20")){
			statusN = StudentPolicyStatus.PendingPay.getText();
		}
		else if(status.equals("30")){
			statusN = StudentPolicyStatus.PendingMakePolicy.getText();
		}
		else if(status.equals("40")){
			statusN = StudentPolicyStatus.PendingOutPolicy.getText();
		}
		else if(status.equals("50")){
			statusN = StudentPolicyStatus.PendingSigned.getText();
		}
		else if(status.equals("60")){
			statusN = StudentPolicyStatus.SendOutPolicy.getText();
		}
		else{
			statusN = StudentPolicyStatus.Expired.getText();
		}
		return statusN;
	}

	public void setStatusN(String statusN){
		this.statusN = statusN;
	}
}